from PIL import Image
import numpy as np
import skimage.color


# A implémenter
def grayscale_contrast(numpy_image):
    numpy_image = numpy_image.astype(np.int32)
    min_value = np.min(numpy_image)
    max_value = np.max(numpy_image)
    return (((numpy_image - min_value) / (max_value - min_value)) * numpy_image).astype(np.uint8)

# A implémenter
def color_contrast(numpy_image):
    numpy_image = numpy_image.astype(np.int32)
    for rgb in [0, 1, 2]:
        min_value = np.min(numpy_image[:, :, rgb])
        max_value = np.max(numpy_image[:, :, rgb])
        numpy_image[:, :, rgb] = (
                    ((numpy_image[:, :, rgb] - min_value) / (max_value - min_value)) * numpy_image[:, :, rgb])
    return numpy_image.astype(np.uint8)

# Code pour la visualisation, ne pas modifier ci-dessous
# Lecture des images
grayscale_image = np.array(Image.open('in/bridge.png').convert("L"))
color_image = np.array(Image.open('in/tree.jpg'))

# Modification du contraste
grayscale_contrasted = grayscale_contrast(grayscale_image)
color_contrasted = color_contrast(color_image)

# Sauvegarde des images
first_line = np.hstack((np.repeat(grayscale_image[:, :, np.newaxis], 3, axis=2), color_image))
second_line = np.hstack((np.repeat(grayscale_contrasted[:, :, np.newaxis], 3, axis=2), color_contrasted))
Image.fromarray(np.vstack([first_line, second_line, ])).save('out/ex2_contrast.jpg')
